Skip to content

# Environment variable

The tool to check the availability or syntax of domain, IP or URL.

::

    ██████╗ ██╗   ██╗███████╗██╗   ██╗███╗   ██╗ ██████╗███████╗██████╗ ██╗     ███████╗
    ██╔══██╗╚██╗ ██╔╝██╔════╝██║   ██║████╗  ██║██╔════╝██╔════╝██╔══██╗██║     ██╔════╝
    ██████╔╝ ╚████╔╝ █████╗  ██║   ██║██╔██╗ ██║██║     █████╗  ██████╔╝██║     █████╗
    ██╔═══╝   ╚██╔╝  ██╔══╝  ██║   ██║██║╚██╗██║██║     ██╔══╝  ██╔══██╗██║     ██╔══╝
    ██║        ██║   ██║     ╚██████╔╝██║ ╚████║╚██████╗███████╗██████╔╝███████╗███████╗
    ╚═╝        ╚═╝   ╚═╝      ╚═════╝ ╚═╝  ╚═══╝ ╚═════╝╚══════╝╚═════╝ ╚══════╝╚══════╝

Provides the environment variable helpers.

Author: Nissar Chababy, @funilrys, contactTATAfunilrysTODTODcom

Special thanks: https://pyfunceble.github.io/#/special-thanks

Contributors: https://pyfunceble.github.io/#/contributors

Project link: https://github.com/funilrys/PyFunceble

Project documentation: https://docs.pyfunceble.com

Project homepage: https://pyfunceble.github.io/

License: ::

    Copyright 2017, 2018, 2019, 2020, 2022, 2023, 2024, 2025 Nissar Chababy

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        https://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

## `EnvironmentVariableHelper`

Simplify the way we work with environment variable.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`name` | `str` | The name of the environment variable to work with. | `None`

Source code in `PyFunceble/helpers/environment_variable.py`

     60
     61
     62
     63
     64
     65
     66
     67
     68
     69
     70
     71
     72
     73
     74
     75
     76
     77
     78
     79
     80
     81
     82
     83
     84
     85
     86
     87
     88
     89
     90
     91
     92
     93
     94
     95
     96
     97
     98
     99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247

    class EnvironmentVariableHelper:
        """
        Simplify the way we work with environment variable.

        :param str name:
            The name of the environment variable to work with.
        """

        _name: Optional[str] = None
        _env_file_path: Optional[str] = None

        def __init__(self, name: Optional[str] = None, env_file_path: Optional[str] = None):
            if name is not None:
                self.name = name

            if env_file_path is not None:
                self.env_file_path = env_file_path

            logging.getLogger("dotenv").setLevel(logging.CRITICAL)

        @property
        def name(self) -> Optional[str]:
            """
            Provides the current state of the :code:`_name` attribute.
            """

            return self._name

        @name.setter
        def name(self, value: str) -> None:
            """
            Sets the name of the environment variable to work with.

            :param value:
                The name to set.

            :raise TypeError:
                When :code:`value` is not a :py:class:`str`
            """

            if not isinstance(value, str):
                raise TypeError(f"<value> should be {str}, {type(value)} given.")

            self._name = value

        def set_name(self, value: str) -> "EnvironmentVariableHelper":
            """
            Sets the name of the environment variable to work with.

            :param value:
                The name to set.
            """

            self.name = value

            return self

        @property
        def env_file_path(self) -> Optional[str]:
            """
            Provides the current state of the :code:`_env_file_path` attribute.
            """

            return self._env_file_path

        @env_file_path.setter
        def env_file_path(self, value: str) -> None:
            """
            Sets the location of the environment file to work with.

            :param value:
                The name to set.

            :raise TypeError:
                When :code:`value` is not a :py:class:`str`
            """

            if not isinstance(value, str):
                raise TypeError(f"<value> should be {str}, {type(value)} given.")

            self._env_file_path = value

        def set_env_file_path(self, value: str) -> "EnvironmentVariableHelper":
            """
            Sets the location of the environment file to work with.

            :param value:
                The name to set.
            """

            self.env_file_path = value

            return self

        def exists(self) -> bool:
            """
            Checks if the given environment variable name exists.
            """

            return self.name in os.environ

        def get_value(self, *, default: Optional[Any] = None) -> Union[Any, str]:
            """
            Returns the value of the given environment variable name
            (if exists.)

            :param default: The default value to return.
            """

            if self.exists():
                return os.environ[self.name]

            return default

        def get_value_from_env_file(
            self, *, default: Optional[Any] = None
        ) -> Union[Any, str]:
            """
            Returns the value of the given environment variable if it exists
            in the given file path.
            """

            read_value = dotenv.get_key(self.env_file_path, self.name)

            if read_value is not None:
                return read_value
            return default

        def set_value(self, value: str) -> "EnvironmentVariableHelper":
            """
            Sets the given value into the given environment variable name.

            :param str value:
                The value to set.

            :raise TypeError:
                When :code:`value` is not a :py:class:`value`.
            """

            if not isinstance(value, str):
                raise TypeError(f"<value> should be {str}, {type(value)} given.")

            os.environ[self.name] = value

            return self

        def set_value_in_env_file(self, value: str) -> "EnvironmentVariableHelper":
            """
            Sets the given value and save it into the given dotenv file.

            .. warning::
                This method also set the environment variable from the current
                environment.

            :param value:
                The value to set.
            """

            self.set_value(value)

            dotenv.set_key(self.env_file_path, self.name, value)

            return self

        def delete(self) -> "EnvironmentVariableHelper":
            """
            Deletes the given environment variable if exists.
            """

            if self.exists():
                del os.environ[self.name]

            return self

        def delete_from_env_file(self) -> "EnvironmentVariableHelper":
            """
            Deletes the given environment file from the given dotenv file.

            .. warning::
                This method also delete the environment variable from the current
                environment.
            """

            self.delete()

            dotenv.unset_key(self.env_file_path, self.name)

            return self

### `env_file_path` `property` `writable`

Provides the current state of the :code:`_env_file_path` attribute.

### `name` `property` `writable`

Provides the current state of the :code:`_name` attribute.

### `delete()`

Deletes the given environment variable if exists.

Source code in `PyFunceble/helpers/environment_variable.py`

    224
    225
    226
    227
    228
    229
    230
    231
    232

    def delete(self) -> "EnvironmentVariableHelper":
        """
        Deletes the given environment variable if exists.
        """

        if self.exists():
            del os.environ[self.name]

        return self

### `delete_from_env_file()`

Deletes the given environment file from the given dotenv file.

.. warning:: This method also delete the environment variable from the current environment.

Source code in `PyFunceble/helpers/environment_variable.py`

    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247

    def delete_from_env_file(self) -> "EnvironmentVariableHelper":
        """
        Deletes the given environment file from the given dotenv file.

        .. warning::
            This method also delete the environment variable from the current
            environment.
        """

        self.delete()

        dotenv.unset_key(self.env_file_path, self.name)

        return self

### `exists()`

Checks if the given environment variable name exists.

Source code in `PyFunceble/helpers/environment_variable.py`

    154
    155
    156
    157
    158
    159

    def exists(self) -> bool:
        """
        Checks if the given environment variable name exists.
        """

        return self.name in os.environ

### `get_value(*, default=None)`

Returns the value of the given environment variable name (if exists.)

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`default` | `Optional[Any]` | The default value to return. | `None`

Source code in `PyFunceble/helpers/environment_variable.py`

    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172

    def get_value(self, *, default: Optional[Any] = None) -> Union[Any, str]:
        """
        Returns the value of the given environment variable name
        (if exists.)

        :param default: The default value to return.
        """

        if self.exists():
            return os.environ[self.name]

        return default

### `get_value_from_env_file(*, default=None)`

Returns the value of the given environment variable if it exists in the given file path.

Source code in `PyFunceble/helpers/environment_variable.py`

    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186

    def get_value_from_env_file(
        self, *, default: Optional[Any] = None
    ) -> Union[Any, str]:
        """
        Returns the value of the given environment variable if it exists
        in the given file path.
        """

        read_value = dotenv.get_key(self.env_file_path, self.name)

        if read_value is not None:
            return read_value
        return default

### `set_env_file_path(value)`

Sets the location of the environment file to work with.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `str` | The name to set. | required

Source code in `PyFunceble/helpers/environment_variable.py`

    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152

    def set_env_file_path(self, value: str) -> "EnvironmentVariableHelper":
        """
        Sets the location of the environment file to work with.

        :param value:
            The name to set.
        """

        self.env_file_path = value

        return self

### `set_name(value)`

Sets the name of the environment variable to work with.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `str` | The name to set. | required

Source code in `PyFunceble/helpers/environment_variable.py`

    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115

    def set_name(self, value: str) -> "EnvironmentVariableHelper":
        """
        Sets the name of the environment variable to work with.

        :param value:
            The name to set.
        """

        self.name = value

        return self

### `set_value(value)`

Sets the given value into the given environment variable name.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `str` | The value to set. | required

Raises:

Type | Description
--- | ---
`TypeError` | When :code:`value` is not a class:`value`.

Source code in `PyFunceble/helpers/environment_variable.py`

    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204

    def set_value(self, value: str) -> "EnvironmentVariableHelper":
        """
        Sets the given value into the given environment variable name.

        :param str value:
            The value to set.

        :raise TypeError:
            When :code:`value` is not a :py:class:`value`.
        """

        if not isinstance(value, str):
            raise TypeError(f"<value> should be {str}, {type(value)} given.")

        os.environ[self.name] = value

        return self

### `set_value_in_env_file(value)`

Sets the given value and save it into the given dotenv file.

.. warning:: This method also set the environment variable from the current environment.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `str` | The value to set. | required

Source code in `PyFunceble/helpers/environment_variable.py`

    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222

    def set_value_in_env_file(self, value: str) -> "EnvironmentVariableHelper":
        """
        Sets the given value and save it into the given dotenv file.

        .. warning::
            This method also set the environment variable from the current
            environment.

        :param value:
            The value to set.
        """

        self.set_value(value)

        dotenv.set_key(self.env_file_path, self.name, value)

        return self